//
//  ViewController.swift
//  Game
//
//  Created by Santiago Pavón on 8/12/14.
//  Copyright (c) 2014 UPM. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var nameTextField: UITextField!
    
    @IBOutlet weak var totalTextField: UITextField!
    
    @IBOutlet weak var statusLabel: UILabel!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    
    @IBAction func save() {
        
        statusLabel.text = "Salvando Puntuación"
        UIApplication.shared.isNetworkActivityIndicatorVisible = true
        
        //--- Datos a subir:
        
        if nameTextField.text == "" {
            nameTextField.text = "Anónimo"
        }
        if totalTextField.text == "" {
            totalTextField.text = "0"
        }
        
        let score = ["name": nameTextField.text!,
                     "total": totalTextField.text!]
        guard let dataScore = try? JSONSerialization.data(withJSONObject: score) else {
            return
        }
        
        //--- URL destino:
        let SCORES_URL = "http://localhost:3000/scores.json"
        let url = URL(string: SCORES_URL)!
  
        //--- La peticion HTTP:
        var request = URLRequest(url: url)
        request.httpMethod = "POST"
        request.addValue("application/json; charset=utf-8", forHTTPHeaderField: "Content-Type")
        
        //--- La sesion:
        let sessionConf = URLSessionConfiguration.ephemeral
        let session = URLSession(configuration: sessionConf)

        
        //--- La tarea para subir los datos:
        let uploadTask = session.uploadTask(with: request, from: dataScore) { (data: Data?, response: URLResponse?, error: Error?) -> Void in
                // El completionHandler no corre en el Main Thread
                DispatchQueue.main.async {
                    if error != nil {
                        self.statusLabel.text = error!.localizedDescription
                    } else if let res = response as? HTTPURLResponse,
                        res.statusCode != 200 && res.statusCode != 201 {
                        let msg = HTTPURLResponse.localizedString(forStatusCode: res.statusCode)
                        self.statusLabel.text = msg
                    } else {
                        self.statusLabel.text = "Subido"
                    }
                    UIApplication.shared.isNetworkActivityIndicatorVisible = false
                }
        }
        uploadTask.resume()
    }
    
    
    @IBAction func hideKeyboard() {
  
        nameTextField.resignFirstResponder()
        totalTextField.resignFirstResponder()
    
    }

}

